class SearchController < ApplicationController
  include SearchEngine::OrientdbLucene

  def index
  end

  def fetch
    objectsFound = []

    params[:subject]= params[:subject].split(', ')
    params[:type] = params[:type].split(', ')
    params[:school_year] = params[:school_year].split(', ')
    params[:year] = params[:year].split('-').take(2)
    page=1
    if (params[:page])
      page = params[:page].to_i
    end

    @pagination_limit=10

    unless params[:query].blank?
      objectsFound = search params
      @numFound = objectsFound.length

      # case params[:order]
      #   items = objectsFound.collect{ |x| Ranking::Item.new(x.name,x.views,0,x.likes,x)  } #puts each object in an item
      #
      #   rater = Ranking::Rater.new(
      #       Ranking::Strategies::BasicRater.new(
      #           #define ordering weights
      #           positionWeight = 1000,
      #           useWeight = 1,
      #           likeWeight = 100
      #       )
      #   )
      #
      #   a = rater.orderByRate(items) # Returns ordered array of items
      #   objectsFound = a.collect{ |x|  x.info  } #get only the info fields(objects)
      # end
    end

    # build objects from one page only
    @objects = build_page_result(objectsFound, page, @pagination_limit)
    
    @result = Kaminari.paginate_array(objectsFound).page(page).per(@pagination_limit)

    render partial: 'search/fetch'
  end

  private

  def build_page_result(objects, page, limit)
    start = (page * limit) - limit
    offset = page * limit - 1
    # build only objects from page
    LearningObjectBuilder.build(objects[start..offset])
  end

  def order_author(items)
    # items = items.order_by{|item| [ item['author'].to_s.downcase ]}
    # items.each{ |item| item['author'] = order_author(item['author']) if (item['author'].nil? ? [] : item['author']).size > 0 }
    items
  end
end
